##' ------------------------------------
##' Random Number Generation
##'
##' Exercise:
##' The following script can be used to generate random numbers
##' in parallel. But there is a big mistake in the script.
##' 1) Run the faulty script and save the resaults.
##' 2) Find the mistake and correct it.
##' 3) Run the corrected script and compare the resaults.
##' ------------------------------------
require("parallel")

## qsub sets the SGE variable NSLOTS
slots <- as.integer(Sys.getenv("NSLOTS"))

# start MPI cluster
clu <- makeCluster(slots, type = "PSOCK")

clusterEvalQ(clu, set.seed(1))
fun <- function(x) mapply(function(x) runif(2), 1:100)

x <- parLapply(clu, 1:100, fun)

saveRDS(x, file="bad_rng_snow.rds")

stopCluster(clu)
